#!/bin/bash

packagesPath='/opt/compatibility_layer/config/install.list'
envList="ubuntu16.04 ubuntu18.04 ubuntu20.04 v10 v10sp1 openkylin1.0 openkylin2.0 local"

function _kare() {
    local shortopts="-i -e -E -b -r -P -l -h"
    local longopts="install remove list run"
    local cur prev words cword

    COMPREPLY=()

    cur="${COMP_WORDS[COMP_CWORD]}"
    prev="${COMP_WORDS[COMP_CWORD - 1]}"
    opts=$(kare -E)
    _init_completion -s || return

    local i=$cword

    # find the last option flag
    if [[ $cur != -* && $cur != install && $cur != remove && $cur != list && $cur != run ]]; then
        while [[ $prev != -* && $prev != install && $prev != remove && $prev != list && $prev != run && $i -ne 1 ]]; do
            prev=${words[--i - 1]}
        done
    fi

    case $prev in
    install | -i)
        _filedir '?(u|d)deb'
        return
        ;;
    remove | -L | -r | -P)
        packagelist=()
        for line in $(cat ${packagesPath}); do
            package=$(echo ${line} | awk -F'=' '{print $1}')
            packagelist[${#packagelist[*]}]=${package}
        done
        COMPREPLY=($(compgen -W "$(echo ${packagelist[@]})" -- ${cur}))
        return
        ;;
    run)
        packagelist=()
        for line in $(cat ${packagesPath}); do
            package=$(echo ${line} | awk -F= '{printf"%s_%s",$1,$2}')
            packagelist[${#packagelist[*]}]=${package}
        done
        COMPREPLY=($(compgen -W "$(echo ${packagelist[@]})" -- ${cur}))
        return
        ;;
    -b)
        COMPREPLY=($(compgen -W "${envList}" -- ${cur}))
        return
        ;;
    -e)
        COMPREPLY=($(compgen -W "${opts}" -- ${cur}))
        return
        ;;
    kare)
        COMPREPLY=($(compgen -W "${shortopts} ${longopts}" -- ${cur}))
        return
        ;;
    esac
} &&
    complete -F _kare kare
